// game.cpp: implementation of the Cgame class.
//
//////////////////////////////////////////////////////////////////////
// entierement pomp sur PERN tutorial, ainsi
// que de qules autres sources de gbadev
// un peu reorganis, et un backgroung scroll...
// c'est juste une base.

#include	"game.h"
#include	"graf.h"

s16 x=0;
s16 y=0;
u16 char_number=0;

FIXED angle=0;
FIXED zoom=1<<8;

FIXED SIN[360];
FIXED COS[360];

Cgame::Cgame()
	{
	}

void	Cgame::init()
	{
	int index=0;
	u16 loop;
	for(loop=0;loop<360;loop++)
		{
		//sin and cos are computed and cast to fixed
		//tres horrible, je devrais faire une table sur 256
		SIN[loop]=(FIXED)(sin(deg2rad(loop))*256);
		COS[loop]=(FIXED)(cos(deg2rad(loop))*256);
		}
	SetMode(MODE_0|OBJ_ENABLE|BG0_ENABLE|OBJ_MAP_1D);
	REG_BG0CNT=BIT02|BIT07;
	//loop through and store the palette from your pict 
	//palette into obj palette mem OBJPaletteMem is 
	//defined in gba.h.  sprite1Palette is from
	//pcx2gba tool sprite1.h. ne pas utiliser hackit, qui a pas l'air de marcher?
	for(loop=0;loop<256;loop++)
		{
		OBJPaletteMem[loop]=prite1Palette[loop];
		BGPaletteMem[loop]=BONHOMMEPalette[loop];
		}
	InitializeSprites(); 
	//set all 128 sprites to offscreen
	//this is were we define our sprite atributes for the first sprite
	//256 color 64x64 sprite that starts at character 0.  Character 0 is
	//the first sprite data memory location.
	sprites[0].attribute0=COLOR_256|SQUARE|ROTATION_FLAG|y; 
	sprites[0].attribute1=SIZE_64|ROTDATA(0)|x;
	sprites[0].attribute2=char_number;

	sprites[1]=sprites[0];
	sprites[1].attribute1=sprites[1].attribute1|ROTDATA(1);
	sprites[1].attribute0=sprites[1].attribute0|SIZE_DOUBLE;
	//allright now to copy in the sprites bitmap.  The data in sprite1Data is allready striped 
	//so we just copy it in one row of tiles at a time.  The only difference between this and a 
	//2D sprite is that we would need to keep in mind the fact that the tiles are not all in a row.
	//We could just use one big for loop.  There are 8 rows(64x64=8x8 tiles)so we loop through
	//all 8.  There is 512 bytes per row(8 tiles * 8x8=512)but since we copy 2 bytes at a 
	//time that equals 256.  The width of char memory is 32 * 8x8=1024(512 double bytes).
	u16*	p=VideoBuffer+8*1024;
	// on pourrait optimiser avec le DMA
	for(int	x=0;x<32;x++)
		for(int	y=0;y<32;y++)
			VideoBuffer[x+y*32]=(y*16+x%15)%(10*16);
	// itou, sprite et fond c'est le meme dessin.
	for(index=0;index<4096;index++)
		{
		OAMData[index]=sprite1Data[index];
		}
	for(index=0;index<4096;index++)
		{
		p[index]=BONHOMMEData[index];
		}
	}

void	Cgame::run()
	{
	init();
	while(1)
		{
		// Main Game loop, do your stuff here	
		GetInput();
		REG_BG0HOFS=x;
		REG_BG0VOFS=y;
		MoveSprite(sprites[0],x,y);
		RotateSprite(0,angle,zoom,zoom);
		MoveSprite(sprites[1],x+60,y);
		RotateSprite(1,angle+180,zoom,zoom);
		WaitForVsync();
		CopyOAM();
		}
	}

//wait for the screen to stop drawing
void	Cgame::WaitForVsync()
	{
	volatile	u16*	a=BGPaletteMem;
	a[0]=0;
	__asm 
		{
		mov		r0,#0x4000006
scanline_wait:
		ldrh	r1,[r0]
		cmp		r1,#160
		bne 	scanline_wait
		}	
	a[0]=255;
	}

//Test for key presses
void	Cgame::GetInput()
	{
	if(!(*KEYS&KEY_UP))		y--;
	if(!(*KEYS&KEY_DOWN))	y++;
	if(!(*KEYS&KEY_LEFT))	x--;
	if(!(*KEYS&KEY_RIGHT))	x++;
	if(!(*KEYS&KEY_A))		zoom--;
	if(!(*KEYS&KEY_B))		zoom++;
	if(!(*KEYS&KEY_L))
		{
		angle--;
		if(angle<0)
			angle=359;
		}
	if(!(*KEYS&KEY_R))
		{
		angle++;
		if(angle>359)
			angle=0;
		}
	if(!(*KEYS&KEY_START))
		{
		if(!(sprites[0].attribute0&SIZE_DOUBLE))//set or clear size double 
			{	
//needs if to keep from holding down the start
//size double shifts the sprite center by half the width and height this just adjusts for it.
			sprites[0].attribute0|=SIZE_DOUBLE;
			x-=32;
			y-=32;
			}
		}
	if(!(*KEYS&KEY_SELECT))
		{
		if((sprites[0].attribute0&SIZE_DOUBLE))
			{
			sprites[0].attribute0&=~SIZE_DOUBLE;
			x+=32;
			y+=32;
			}
		}
	}
