#include	"sprite.h"


u16* OAM=(u16*)0x7000000;
OAMEntry sprites[128];
RotData* rotData=(RotData*)sprites;

//Set sprites to off screen
void	InitializeSprites()
	{
	for(int	loop=0;loop<128;loop++)
		{
		sprites[loop].attribute0=160; //y to>159
		sprites[loop].attribute1=240; //x to>239
		}
	}


//move the sprite
void	MoveSprite(OAMEntry&	sp,int x,int y)
	{
	//if it is off the left corect
	if(x<0)		x=512+x;
	//if off the top corect
	if(y<0)		y=256+y;
	sp.attribute1=sp.attribute1&0xFE00; //clear the old x value
	sp.attribute1=sp.attribute1|x;
	
	sp.attribute0=sp.attribute0&0xFF00; //clear the old y value
	sp.attribute0=sp.attribute0|y;
	}

void	RotateSprite(int rotDataIndex,int angle,FIXED x_scale,FIXED y_scale)
	{
	FIXED pa,pb,pc,pd;

	pa=((x_scale)* COS[angle])	>>8;   //(do my fixed point multiplies and shift back down)
	pb=((y_scale)* SIN[angle])	>>8;
	pc=((x_scale)* -SIN[angle])	>>8;
	pd=((y_scale)* COS[angle])	>>8;
	
	rotData[rotDataIndex].pa=pa; //put them in my data struct
	rotData[rotDataIndex].pb=pb;
	rotData[rotDataIndex].pc=pc;
	rotData[rotDataIndex].pd=pd;
	}

//Copy our sprite array to OAM
void	CopyOAM()
	{
	u16 loop;
	u16* temp;
	temp=(u16*)sprites;
	for(loop=0;loop<128*4;loop++)
		OAM[loop]=temp[loop];
	}