#ifndef SPRITE_H
#define SPRITE_H

#include	"gba.h"
	
//Atribute0 stuff
enum	atribut0
	{
	ROTATION_FLAG		=0x100,
	SIZE_DOUBLE			=0x200,
	MODE_NORMAL			=0x0,
	MODE_TRANSPERANT	=0x400,
	MODE_WINDOWED		=0x800,
	MOSAIC				=0x1000,
	COLOR_16			=0x0000,
	COLOR_256			=0x2000,
	SQUARE				=0x0,
	TALL				=0x4000,
	WIDE				=0x8000
	};

#define	ROTDATA(n)			((n)<<9)
//Atribute1 stuff
enum	atribut1
	{
	HORIZONTAL_FLIP=	0x1000,
	VERTICAL_FLIP=		0x2000,
	SIZE_8=				0x0,
	SIZE_16=			0x4000,
	SIZE_32=			0x8000,
	SIZE_64=			0xC000
	};

//atribute2 stuff
#define PRIORITY(n)			((n)<<10)
#define PALETTE(n)			((n)<<12)

/////structs/////
struct	OAMEntry
	{
	u16 attribute0;
	u16 attribute1;
	u16 attribute2;
	u16 attribute3;
	};

struct	RotData
	{
	u16 filler1[3];
	u16 pa;
	
	u16 filler2[3];
	u16 pb;	
	
	u16 filler3[3];
	u16 pc;	
	
	u16 filler4[3];
	u16 pd;
	};

extern	u16* OAM;
extern	OAMEntry sprites[128];
extern	RotData* rotData;

void	InitializeSprites();
void	MoveSprite(OAMEntry&	sp,int x,int y);
void	RotateSprite(int rotDataIndex,int angle,FIXED x_scale,FIXED y_scale);
void	CopyOAM();

#endif